#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name = "MapMaxPlayers",
	author = "wS / Schmidt",
	description = "Кол-во слотов зависит от текущей карты",
	version = "1.0",
	url = "http://world-source.ru/forum/118"
};

new MAX_SLOTS, Handle:sv_visiblemaxplayers;

public OnPluginStart()
{
	sv_visiblemaxplayers = FindConVar("sv_visiblemaxplayers");
}

public OnMapStart()
{
	new Handle:kv = CreateKeyValues("MapMaxPlayers");
	if (FileToKeyValues(kv, "cfg/MapMaxPlayers.txt"))
	{
		decl String:map[135]; GetCurrentMap(map, 135);
		if (KvJumpToKey(kv, map) && (MAX_SLOTS = KvGetNum(kv, "max_slots")) > 0)
		{
			if (MAX_SLOTS > MaxClients) MAX_SLOTS = MaxClients;
			SetConVarInt(sv_visiblemaxplayers, MAX_SLOTS);
			CloseHandle(kv);
			return;
		}
	}
	else LogError("cfg/MapMaxPlayers.txt - FileToKeyValues error");
	CloseHandle(kv);
	MAX_SLOTS = 0; SetConVarInt(sv_visiblemaxplayers, -1);
}

public bool:OnClientConnect(client, String:rejectmsg[], maxlen)
{
	if (MAX_SLOTS > 0 && ServerFull())
	{
		strcopy(rejectmsg, maxlen, "Сервер забит");
		return false;
	}
	return true;
}

bool:ServerFull()
{
	new players = 0;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && ++players >= MAX_SLOTS) return true;
	}
	return false;
}